// noinspection DuplicatedCode

window._backup_console = window.console
window._backup_console_log = window.console.log

function _th_log(msg) {
    if (window.cc && window.cc.error) {
        window.cc.error(msg);
    } else if (window.cc && window.cc.warn) {
        window.cc.warn(msg);
    } else {
        window._backup_console_log.call(window._backup_console_log, msg)
    }
}

_th_log('all_in_once begin for url: ' + location.toString());

function in_frame() {
    try {
        return window.top !== window.self;
    } catch (e) {
        return true;
    }
}

function has_sub_frame() {
    return document.getElementsByTagName("iframe").length > 0;
}

function is_cocos() {
    return !!window.cc;
}

function is_egret() {
    return !!window.egret;
}

function get_infos() {
    return 'is_egret: ' + is_egret() + ', is_coos: ' + is_cocos() + ', has_sub_frame: ' +
        has_sub_frame() + ', in_frame: ' + in_frame() + ', in_game: ' + is_game();
}

function is_game() {
    return is_egret() || is_cocos() || !has_sub_frame();
}

function _tt_get_speed() {
    let speed = window.__speed || 1.0;
    const enable = window.__enable_speed !== false;
    if (!enable) {
        speed = 1.0;
    }
    return speed;
}

function _th_init_by_inject_time() {
    _th_log('_th_init_by_inject_time called for url: ' + window.location)
    Date._now = Date._now || Date.now;
    performance._now = performance._now || performance.now;
    Date.prototype._getTime = Date.prototype._getTime || Date.prototype.getTime;

    window._now_mem = {
        base: 0,
        rst: 0
    };

    window._performance_mem = {
        base: 0,
        rst: 0
    };

    function _calc(now_getter, thiz, mem) {
        try {
            let speed = _tt_get_speed()
            if (!mem.base) {
                mem.base = now_getter.call(thiz);
                mem.rst = now_getter.call(thiz);
            }
            const rst = mem.rst + (now_getter.call(thiz) - mem.base) * speed;
            mem.rst = rst;
            mem.base = now_getter.call(thiz);
            return rst;
        } catch (e) {
            _th_log(e.stack)
            throw e;
        }
    }

    Date.now = function () {
        return _calc(Date._now, this, window._now_mem);
    };

    performance.now = function () {
        return _calc(performance._now, this, window._performance_mem);
    };
}

window._tt_has_init_inject = false
window._tt_has_tianxiace_inject = false
window._tt_has_init_calc_delta_time = false

const _CHECK_DELTA_TIME_INJECT = "_CHECK_DELTA_TIME_INJECT"

function _init_inject() {
    if (!window._tt_has_tianxiace_inject) {
        if (window.game && window.game.BattleAction && window.game.BattleAction.prototype.start) {
            _th_init_tianxiace(_tt_get_speed)
            window._tt_has_tianxiace_inject = true
        }
    }

    _th_log('window._tt_has_init_calc_delta_time: ' + window._tt_has_init_calc_delta_time)
    if (is_cocos() && window.cc.director && window.cc.director.calculateDeltaTime && window.cc.director.calculateDeltaTime.length === 1) {
        const funcStr = window.cc.director.calculateDeltaTime.toString()
        // maybe changed back, so check again
        if (funcStr.indexOf('_CHECK_DELTA_TIME_INJECT') < 0) {
            _th_log('real do inject calculateDeltaTime')
            const old = window.cc.director.calculateDeltaTime
            const mem = { base: 0, rst: 0 }
            window.cc.director.calculateDeltaTime = function(t) {
                if (1 === 0) {
                    console.log(_CHECK_DELTA_TIME_INJECT)
                }
                if (!mem.base) {
                    mem.base = t
                    mem.rst = t
                }
                const speed = _tt_get_speed()
                const rst = mem.rst + (t - mem.base) * speed;
                mem.rst = rst;
                mem.base = t
                old.call(this, rst)
            }
        }
        return;
    }

    if (window._tt_has_init_inject) {
        _th_log('_init_inject already injected!!')
        return
    }
    window._tt_has_init_inject = true
    _th_log('_init_inject game info: ' + get_infos())
    _th_init_by_inject_time();
}

function _th_init_tianxiace(scale_getter) {
    if (!(window.game && window.game.BattleAction && window.game.BattleAction.prototype.start)) {
        return
    }
    // 这里怎么会有错误呢？？
    const _origin = window.game.BattleAction.prototype.start
    const max_speed = 3
    window.game.BattleAction.prototype.start = function() {
        let scale = scale_getter()
        if (!scale) {
            scale = 1
        }
        if (scale > max_speed) {
            scale = max_speed
        }
        if (window.DB) {
            window.DB.ins.otherDB.battleSpeed = scale
        }
        _origin.call(this)
    }
}

function _send_msg_to_frame(msg) {
    for (const ele of document.getElementsByTagName('iframe')) {
        _th_log('send msg to child frame: ' + JSON.stringify(msg) + ", frame src: ", ele.src);
        if (ele.contentWindow) {
            ele.contentWindow.postMessage(msg, '*');
        }
    }
}

if (window.__speed !== null && window.__speed !== undefined) {
    window.__speed = 1.0;
}

window.setSpeed = function (speed) {
    _th_log('setSpeed called, ' + get_infos() + ", url: " + location.toString());
    _send_msg_to_frame({
        type: 'tt_setSpeed',
        speed
    });
    if (is_game()) {
        _th_log('in_game, so real set speed to: ' + speed + ', for url: ' + location.toString() + ", enabled: " + window.__enable_speed);
        _init_inject()
        window.__speed = speed;
    } else {
        _th_log('is not in game');
    }
};

window.setEnable = function (enable) {
    _send_msg_to_frame({
        type: 'tt_setEnable',
        enable
    });
    if (is_game()) {
        _init_inject()
        window.__enable_speed = enable;
    }
};

addEventListener('message', function (param) {
    if (param && param.data) {
        const data = param.data;
        if (data.type && data.type.startsWith('tt_')) {
            _th_log('receive msg: ' + JSON.stringify(data));
            if (data.type === 'tt_setSpeed') {
                setSpeed(data.speed);
            } else if (data.type === 'tt_setEnable') {
                setEnable(data.enable);
            }
        }
    }
}, false);

_th_log('all_in_once finish for url: ' + location.toString());