function log(msg) {
    if (window.cc && window.cc.error) {
        window.cc.error(msg)
    } else if (window.cc && window.cc.warn) {
        window.cc.warn(msg)
    } else {
        console.log(msg)
    }
}

(function() {
    if (!window.cc || !cc.director) {
        return;
    }

    if (window.sg_setSpeed) {
        // already init
        return
    }

    window.sg_setSpeed = function(speed) {
        window.sg_speed = speed
    }

    window.sg_setEnable = function(enable) {
        window.sg_enable = enable
    }

    window.setSpeed = window.sg_setSpeed
    window.setEnable = window.sg_setEnable

    window.__deltaTime_origin = -1
    window.__deltaTime_changed = -1

    cc.director._calculateDeltaTime = cc.director._calculateDeltaTime || cc.director.calculateDeltaTime
    function getNowFunction() {
        cc.director._calculateDeltaTime()
        const originLastUpdate = cc.director._lastUpdate
        if (!originLastUpdate) {
            return performance.now
        } else {
            // is is time stamp then is Date.now
            // otherwise is performance.now
            if (originLastUpdate.toString().length === 13) {
                return Date.now
            }
            return performance.now
        }
    }

    const nowFunction = getNowFunction()

    cc.director.calculateDeltaTime = function() {
        const base = nowFunction()
        if (window.__deltaTime_origin <= 0) {
            window.__deltaTime_origin = base
            window.__deltaTime_changed = base
        }
        const diff = base - __deltaTime_origin
        let speed = window.sg_speed || 1
        if (!window.sg_enable) {
            speed = 1
        }
        const fixedDiff = diff * speed
        const fixedNow = __deltaTime_changed + fixedDiff
        window.cc.director._deltaTime = fixedDiff / 1000
        log('base: ' + base + ', __deltaTime_origin: '
            + __deltaTime_origin + ', diff: ' + diff + ', enable: ' + window.sg_enable + ', speed: '
            + speed + ', fixedDiff: ' + fixedDiff)
        // log('_deltaTime: '  + window.cc.director._deltaTime)

        window.cc.director._lastUpdate = base
        window.__deltaTime_origin = base
        window.__deltaTime_changed = fixedNow
    }
})()
